function xout = filter_dropsonde(xin, frac, nterm)
% matlab implementation of "subroutine lopass" from the GPS dropsonde 
% processing software by James Franklin.

nmax = length(xin);
xout = zeros(size(xin));
xin = xin(:);

xout(1) = xin(1);
xout(nmax) = xin(nmax);

for L = 2:nmax-1
   mterm = min([ nterm, L-1, nmax-L ]);
   ix = [1 : mterm]';
   %% Calculate Weights
   fac = (2*pi/(2*mterm + 1)) * ix;
   wt = sin( pi*frac*ix ) .* sin(fac) ./ ( pi*ix.*fac );
   wto = frac;
   wtsum = 2*sum(wt) + wto;
   wto = wto/wtsum; wt = wt/wtsum;

   xout(L) = wt'*(xin(L+1 : L+mterm) + xin(L-1 : -1 : L-mterm)) + xin(L)*wto;
end

disp('WARNING filter_dropsonde NOT TESTED');


