function [sf,ff] = filtspec(s,f,n)
% function [sf,ff] = filtspec(s,f,n)
% Filters (bin-averages) a spectrum

fmin = min( f( find(f > 0) ) ); 
fmax = max(f);
df = (fmax/fmin)^(1/n);

sf = zeros(n,1) + nan; ff = zeros(n,1) + nan;
flo = fmin; fhi = fmin*df; igot = 1;
for ii = 1 : n
   ix = find( flo <= f & f <= fhi );
   if ~isempty(ix)
      sf(igot) = exp( mean( log(s(ix)) ) );
      ff(igot) = exp( mean( log(f(ix)) ) );
      igot = igot + 1;
   end
   flo = fhi; fhi = fhi*df;
end
