function error = fit_willoughby_pz(beta)
% Use in conjunction with plotFRD_sfc.m to fit a bogus to Hurricane Mitch

global pobs xobs yobs

xdis = beta(5); ydis = beta(6);
rfix = hypot(xobs - xdis, yobs - ydis);
pfit = willoughby_pv(beta(1:4), rfix);
use = find( ~isnan(pobs) & ~isnan(pfit) );

error = mean( (pfit(use) - pobs(use)).^2 );
