function p = holland_p(beta,r)
% function p = holland_p(beta,r)
% Holland parametric pressure profile
% beta = [ vm rm b pc ]

b  = beta(1);
rm = beta(2);
pc = beta(3);
pe = beta(4);
dp = pe - pc;
rmrb = (rm./r).^b;

p = pc + dp*exp(-rmrb);

p(find(isnan(r))) = nan;
