function v = holland_v2(beta,r,f)
% function v = holland_v(beta,r,f)
% Used for nonlinear fit in FitBogus

if (nargin <= 2), 
   global f0;
   f = f0; 
end;

b1 = beta(1);
b2 = beta(2);
rm = beta(3);
pc = beta(4);
pe = beta(5);
ixin = find(r <= rm);
ixout = find(r > rm);
rmrbin = (rm./r(ixin)).^b1;
rmrbout = (rm./r(ixout)).^b2;

dp = pe - pc;
p = zeros(size(r));
p(ixin) = pc + dp*exp(-rmrbin);
p(ixout) = pc + dp*exp(-rmrbout);
rho = p*100/(287*298);

v = zeros(size(r));
v(ixin) = sqrt( b1*dp*100./rho(ixin) .* exp(-rmrbin) .* rmrbin + (0.5*f*r(ixin)).^2 ) - 0.5*f*r(ixin);
v(ixout) = sqrt( b2*dp*100./rho(ixout) .* exp(-rmrbout) .* rmrbout + (0.5*f*r(ixout)).^2 ) - 0.5*f*r(ixout);
