load('Hurr_Georges_Map');

x = load('Georges_track.dat');
t_tr   = datenum(1998,x(:,1),x(:,2),floor(x(:,3)/100),mod(x(:,3),100),0);
lat_tr = x(:,4);
lon_tr = -x(:,5);
pc_tr  = x(:,6);
spd_tr = x(:,7);

names = [ '19980918h';
          '19980918n';
          '19980919h';
          '19980919i';
          '19980919n';
          '19980921h';
          '19980921i';
          '19980921n';
          '19980922i';
          '19980922n';
          '19980923h';
          '19980923n';
          '19980924h';
          '19980925h';
          '19980925i';
          '19980925n';
          '19980926n';
          '19980928h';
          '19980928i';
          '19981024n';
          '19981025h';
          '19981027i'; ];

for ii = 1 : size(names,1)

   fname = names(ii,:)

   [time, p, Ta, RH, dir, spd, lon, lat, z] = ReadHSA(fname);
   theta = (Ta + 273.15) .* (1000./p).^0.2857;

   switch lower(fname(length(fname)))
      case('h') 
         plane = 'N42RF';
      case('i') 
         plane = 'N43RF';
      case('n') 
         plane = 'G-IV';
      otherwise
         plane = '???';
   end

   tclat = interp1(t_tr,lat_tr,time(1));
   tclon = interp1(t_tr,lon_tr,time(1));

   fig(ii); clf;
   subplot(2,2,1); cla; plot(-lon,lat,'b-o'); hold on; plot(tclon,tclat,'r*');
   plot(map_lon,map_lat,'k-'); xylim(-100,-40,0,40);
   set(gca,'DataAspectRatio',[cos(pi/9) 1 1]);
   title([ plane '  ' datestr(time(1)) ]);
   subplot(2,2,2); cla; plot(theta,z); 
   xlabel('\theta'); ylim(0,3000); 
   subplot(2,2,3); cla; plot(spd,z);
   xlabel('speed'); ylim(0,3000);
   subplot(2,2,4); cla; plot(dir,z);
   xlabel('Dir'); ylim(0,3000); xlim(0,360); set(gca,'XTick',[0:90:360]);

   cprint(ii);

end

