% plot_trackstats.m
% Plots stats from ideal_track, for the Objective track paper.

clear
clear global

nobs = [ 15 20 30 50 100 ]';
nn = length(nobs);

meanss = zeros(nn,5);
medianss = zeros(nn,5);
sbiasxwc = zeros(nn,4);
sbiasxwce = zeros(nn,4);
sbiasxs  = zeros(nn,4);
sbiasxhp = zeros(nn,4);
sbiasxhv = zeros(nn,4);

fname = 'ideal_track_ln4802_L01_N%03d_sP050_sV2_05';
fname = 'ideal_track_ln4802_L15_N%03d_sP100_sV2_10';

for ii = 1 : nn
   load(sprintf(fname,nobs(ii)),  'means', 'medians', 'bias*');

   meanss(ii,:) = means;
   medianss(ii,:) = medians;
   sbiasxwc(ii,:) = [ mean(biasxwc), mean(biasywc), std(biasxwc), std(biasywc) ];
   sbiasxwce(ii,:) = [ mean(biasxwce), mean(biasywce), std(biasxwce), std(biasywce) ];
   sbiasxs(ii,:) = [ mean(biasxs), mean(biasys), std(biasxs), std(biasys) ];
   sbiasxhp(ii,:) = [ mean(biasxhp), mean(biasyhp), std(biasxhp), std(biasyhp) ];
   sbiasxhv(ii,:) = [ mean(biasxhv), mean(biasyhv), std(biasxhv), std(biasyhv) ];
end

load(sprintf(fname, 21),  'means', 'medians', 'bias*');
means21   = means;
medians21 = medians;
sbiasxwc21 = [ mean(biasxwc), mean(biasywc), std(biasxwc), std(biasywc) ];
sbiasxwce21 = [ mean(biasxwce), mean(biasywce), std(biasxwce), std(biasywce) ];
sbiasxs21 = [ mean(biasxs), mean(biasys), std(biasxs), std(biasys) ];
sbiasxhp21 = [ mean(biasxhp), mean(biasyhp), std(biasxhp), std(biasyhp) ];
sbiasxhv21 = [ mean(biasxhv), mean(biasyhv), std(biasxhv), std(biasyhv) ];

fig(1); clf;
plot(nobs, meanss(:,1)/1e3, 'k-o', 'MarkerFaceColor','k'); hold on;
plot(nobs, meanss(:,2)/1e3, 'k:o', 'MarkerFaceColor','w');
plot(nobs, meanss(:,3)/1e3, 'k--s', 'MarkerFaceColor','k');
plot(nobs, meanss(:,4)/1e3, 'k-d', 'Linewidth',2, 'MarkerFaceColor','k');
plot(10, means21(1)/1e3, 'ko', 'MarkerSize',8, 'MarkerFaceColor','k');
plot(10, means21(2)/1e3, 'ko', 'MarkerSize',8, 'MarkerFaceColor','w');
plot(10, means21(3)/1e3, 'ks', 'MarkerSize',8, 'MarkerFaceColor','k');
plot(10, means21(4)/1e3, 'kd', 'MarkerSize',8, 'MarkerFaceColor','k');
legend('WC','WCE','MHG','TPF');
xlabel('N_{obs}'); ylabel('Mean RMS Track Error (km)');
xlim(0,100); ylim(0,10);
title(fname,'Interpreter','none');

fig(2); clf;
plot(sbiasxwc(:,1)/1e3,sbiasxwc(:,2)/1e3,'k-o', 'MarkerFaceColor','k'); hold on;
plot(sbiasxwce(:,1)/1e3,sbiasxwce(:,2)/1e3,'k:o', 'MarkerFaceColor','w'); 
plot(sbiasxs(:,1)/1e3,sbiasxs(:,2)/1e3,'k-s', 'MarkerFaceColor','k'); 
plot(sbiasxhp(:,1)/1e3,sbiasxhp(:,2)/1e3,'k-d', 'LineWidth',2, 'MarkerFaceColor','k'); 
% plot(sbiasxwc21(1)/1e3,sbiasxwc21(2)/1e3,'ko', 'MarkerFaceColor','k'); 
% plot(sbiasxwce21(1)/1e3,sbiasxwce21(2)/1e3,'ko', 'MarkerFaceColor','w'); 
% plot(sbiasxs21(1)/1e3,sbiasxs21(2)/1e3,'ks', 'MarkerFaceColor','k'); 
% plot(sbiasxhp21(1)/1e3,sbiasxhp21(2)/1e3,'kd', 'MarkerFaceColor','k'); 
xylim(-10,5,-13,2); hline(0); vline(0);
legend('WC','WCE','MHG','TPF');
xlabel('Mean x-bias (km)'); ylabel('Mean y-bias (km)');
title(fname,'Interpreter','none');


