function [y, dy] = ratfun(x, ab)

oa = 4; ob = 3;   % orders of polys

if length(ab) ~= oa+ob
   disp(sprintf('ratfun>> ERROR length(ab)=%d, oa=%d, ob=%d mismatch',length(oa),oa,ob));
   y = nan; dy = nan;
   return
end

x = x(:)';    % row vector
ab = ab(:);   % column vector

nx = length(x);
x2 = x.^2;
a = ab(oa:-1:1);
b = [ ab(oa+1 : oa+ob) ];

apol = polyval(a,x2);
bpol = prod( 1 + b*x2 );  % (1 + b1*x2)(1 + b2*x2) ... (1 + bn*x2)

y = apol ./ bpol;

if nargout == 2
   dy = repmat(nan, [nx, oa+ob+1]);
   dapol = polyval( a(1:oa-1).*(oa-1:-1:1)', x2 );
   dbpol = 0;
   for ii = 1 : ob
      dbpol = dbpol + b(ii)./(1 + b(ii)*x2);
   end
   dbpol = 2 * x .* bpol .* dbpol;

   for ii = 1 : oa
      dy(:,ii) = x2.^(ii-1) ./ bpol;
   end
   for ii = 1 : ob
      dy(:,oa+ii) = -x2 .* apol ./ ( (1 + b(ii)*x2).*bpol );
   end
   dy(:,oa+ob+1) = 2*x.*(dapol.*bpol - apol.*dbpol) ./ bpol.^2;
end

