function [y, dy] = ratfun2(x, ab)

oa = 4;    % orders of polys

if length(ab) ~= oa+2
   disp(sprintf('ratfun>> ERROR length(ab)=%d, oa=%d mismatch',length(oa),oa));
   y = nan; dy = nan;
   return
end

x = x(:)';    % row vector
ab = ab(:);   % column vector

nx = length(x);
x2 = x.^2;
a = ab(oa:-1:1);
b = ab(oa+1);
n = ab(oa+2);

apol = polyval(a,x2);
bpol = ( 1 + b*x2 ).^n;  

y = apol ./ bpol;

if nargout == 2
   dy = repmat(nan, [nx, oa+2]);
   dapol = polyval( a(1:oa-1).*(oa-1:-1:1)', x2 );
   dbpol = n * b * (1 + b*x2).^(n-1) ;

   for ii = 1 : oa
      dy(:,ii) = x2.^(ii-1) ./ bpol;
   end
   dy(:,oa+1) = -n * x2 .* apol ./ ( (1 + b*x2).^(n+1) );
   dy(:,oa+2) = nan;
   dy(:,oa+3) = 2*x.*(dapol.*bpol - apol.*dbpol) ./ bpol.^2;
end

