% Check derivatives
clear;
a = [10 30e3 4 90]';
r = [ 40e3 ];
for ii = 1 : 4
   del = 1e-06; 
   a1 = a; a1(ii) = a1(ii)*(1 + del);
   [T1,dT1] = holland_T(r,a1);
   a0 = a; a0(ii) = a0(ii)*(1 - del);
   [T0,dT0] = holland_T(r,a0);
   [T2,dT2] = holland_T(r,a);
   [ (T1 - T0)/(a1(ii) - a0(ii))  dT2(:,ii) ]
end
rr = [ r*(1-del); r; r*(1+del) ];
[TT,dTT] = holland_T(rr,a0);
[ (TT(3) - TT(1))/(rr(3) - rr(1))  dTT(2,5) ]

% Down to here

% Test mrqmin fitting
clear;
aa = [50,25e3,1.3,95000]'; na = length(aa);
f = cor(15); rho = 1.15;
r = 1e3*[1 3 20:1:30  80:4:100]'; nr = length(r);
%r = 1e3*[1 3 20:1:30  80:4:100 200:100:1000]'; nr = length(r);
sig = 050*ones(nr,1); 
rfit = 1e3*[1 : 120]'; drfit = rfit(2) - rfit(1);
ptrue = holland_p(rfit,aa);
penv = holland_p(1e6,aa);
vtrue = holland_v(rfit,aa,f);

nmc = 100;
amc = zeros(nmc,na);
chisq = zeros(nmc,1);
pomc = zeros(nmc,nr);
doplot = (nmc == 1);
for ii = 1 : nmc
   po = holland_p(r,aa) + sig.*randn(nr,1);
   pomc(ii,:) = po';
   %a0 = aa .* (1 + 0.05*randn(size(aa))); a0(2) = 70e3;
   a0 = aa;%[50 40e3 1.3 95000]';
   
   % Fudge to keep length scale  and rm under control
   if 1
      r1 = [ r ; -999.0 ]; po1 = [ po ; 0 ]; sig1 = [ sig ; 1 ];
   else
      r1 = r; po1 = po; sig1 = sig;
   end
   [a,cov,chisq(ii)] = mrqmin(r1, po1, sig1, a0, 'holland_p', 100, 2);

   amc(ii,:) = a';
   
   pfit = holland_p(rfit,amc(ii,:)');
   vfit = holland_v(rfit,amc(ii,:)',f);
   
   if doplot
      fig(1); clf;
      subplot(3,1,1); cla;
      plot(r/1e3,pomc(ii,:)/1e2,'bo'); hold on; xlim(0,120); ylim(940,1010);
      plot(rfit/1e3,pfit/1e2,'r');
      plot(rfit/1e3,ptrue/1e2,'g-');
      subplot(3,1,2); cla;
      plot(rfit/1e3,(pfit-ptrue)/1e2,'r'); hold on; xlim(0,120);
      subplot(3,1,3); cla;
      plot(rfit/1e3,vfit,'r'); hold on; xlim(0,120); ylim(0,60);
      plot(rfit/1e3,vtrue,'g-');     
      reltext(0.5,0.8,sprintf('vm true=%.1f fit=%.1f m/s',aa(1),amc(ii,1)));
   end
end

%save test_holland_p

bara = mean(amc); siga = std(amc);
astats = [ bara-siga ; bara ; bara+siga ];

fig(2); clf;
subplot(2,2,1); cla;
plot(amc(:,1),chisq,'o'); hold on; plot(astats(:,1),[0 0 0],'r*');
xlabel('vm'); vline(aa(1)); ylabel('\chi^2');
subplot(2,2,2); cla;
plot(amc(:,2)/1e3,chisq,'o'); hold on; plot(astats(:,2)/1e3,[0 0 0],'r*');
vline(aa(2)/1e3); xlabel('rm'); 
subplot(2,2,3); cla;
plot(amc(:,3),chisq,'o'); hold on; plot(astats(:,3),[0 0 0],'r*');
vline(aa(3)); xlabel('b'); ylabel('\chi^2');
subplot(2,2,4); cla;
plot(amc(:,4)/1e2,chisq,'o'); hold on; plot(astats(:,4)/1e2,[0 0 0],'r*');
vline(aa(4)/1e2); xlabel('pc');



