% 
clear
a = [0.6 100e3 500 10 298]';
dr = 2e2;
f = cor(15);
r = [0:dr:200e3]';
[z,dz] = plprof_z(r,a);
fig(1); clf;
subplot(2,3,1); cla; plot(r/1e3,z);
subplot(2,3,2); cla; plot(r/1e3,dz(:,1));
subplot(2,3,3); cla; plot(r/1e3,dz(:,2));
subplot(2,3,4); cla; plot(r/1e3,dz(:,3));
subplot(2,3,5); cla; plot(r/1e3,dz(:,4));
subplot(2,3,6); cla; plot(r/1e3,dz(:,5));

% Check derivatives
clear;
a = [0.2 -100e3 500 10 289]';
r = [ 4e6 ];
for ii = 1 : 5
   del = 1e-06; 
   a1 = a; a1(ii) = a1(ii)*(1 + del);
   [z1,dz1] = plprof_z(r,a1);
   a0 = a; a0(ii) = a0(ii)*(1 - del);
   [z0,dz0] = plprof_z(r,a0);
   [z2,dz2] = plprof_z(r,a);
   [ (z1 - z0)/(a1(ii) - a0(ii))  dz2(:,ii) ]
end

% Test mrqmin fitting
clear;
aa = [0.2 100e3 500 200 289]'; na = length(aa);
r = 1e3*[1 3 20:1:30  80:4:100]'; nr = length(r);
sig = 010*ones(nr,1); 
rfit = 1e3*[1 : 120]'; drfit = rfit(2) - rfit(1);
ztrue = plprof_z(rfit,aa);
zenv = plprof_z(1e6,aa);

nmc = 100;
amc = zeros(nmc,na);
chisq = zeros(nmc,1);
pomc = zeros(nmc,nr);
doplot = (nmc == 1);
for ii = 1 : nmc
   zo = plprof_z(r,aa) + sig.*randn(nr,1);
   zomc(ii,:) = zo';
   a0 = aa.*(1 + 0.1*randn(5,1));
   
   r1 = r; zo1 = zo; sig1 = sig; ia = [1 1 1 1 0]';
   [a,cov,chisq(ii)] = mrqmin(r1, zo1, sig1, a0,  ia, @plprof_z, 100, 10);

   a(1) = abs(a(1));
   a(2) = abs(a(2));

   amc(ii,:) = a';
   
   zfit = plprof_z(rfit,amc(ii,:)');
   
   if doplot
      fig(1); clf;
      subplot(2,1,1); cla;
      plot(r/1e3,zomc(ii,:),'bo'); hold on; xlim(0,120); 
      plot(rfit/1e3,zfit,'r');
      plot(rfit/1e3,ztrue,'g-');
      subplot(2,1,2); cla;
      plot(rfit/1e3,(zfit-ztrue),'r'); hold on; xlim(0,120);
   end
end

%save test_plprof_z

bara = mean(amc); siga = std(amc);
astats = [ bara-siga ; bara ; bara+siga ];

fig(2); clf;
subplot(2,2,1); cla;
plot(amc(:,1),chisq,'o'); hold on; plot(astats(:,1),[0 0 0],'r*');
xlabel('\alpha'); vline(aa(1)); ylabel('\chi^2');
subplot(2,2,2); cla;
plot(amc(:,2)/1e3,chisq,'o'); hold on; plot(astats(:,2)/1e3,[0 0 0],'r*');
vline(aa(2)/1e3); xlabel('rs'); 
subplot(2,2,3); cla;
plot(amc(:,3),chisq,'o'); hold on; plot(astats(:,3),[0 0 0],'r*');
vline(aa(3)); xlabel('z_c'); ylabel('\chi^2');
subplot(2,2,4); cla;
plot(amc(:,4)/1e2,chisq,'o'); hold on; plot(astats(:,4)/1e2,[0 0 0],'r*');
vline(aa(4)/1e2); xlabel('z_g');



