a = [30 50e3 20 250e3 30e3 2 95000 298]';
dr = 2e2;
f = cor(15);
r = [0:dr:100e3]';
[pn,dpn] = willoughby2_p_noblend(r,a,f);
[p,dp] = willoughby2_p_numerical(r,a,f);
[v,dv] = willoughby2_v(r,a);
gwe = v .* ( v./(r+1e-30) + f );
fig(1); clf; plot(r/1e3,[p,pn]/1e2,'-');

subplot(2,3,1); cla; plot(r/1e3,[p,pn]/1e2);
subplot(2,3,2); cla; plot(r/1e3,[dp(:,1),dpn(:,1)]);
subplot(2,3,3); cla; plot(r/1e3,[dp(:,2),dpn(:,2)]);
subplot(2,3,4); cla; plot(r/1e3,[dp(:,3),dpn(:,3)]);
subplot(2,3,5); cla; plot(r/1e3,[dp(:,4),dpn(:,4)]);
subplot(2,3,6); cla; plot(r/1e3,[dp(:,5),dpn(:,5)]);

% Check derivatives of no_blend version
global f0
f0 = cor(15);
a = [30 5e4 20 3e6 22e3 2.5 92000 298]';
r = [ 77e3 ];
for ii = 1 : 8
   del = 1e-06; 
   a1 = a; a1(ii) = a1(ii)*(1 + del);
   [p1,dp1] = willoughby2_p_noblend(r,a1);
   a0 = a; a0(ii) = a0(ii)*(1 - del);
   [p0,dp0] = willoughby2_p_noblend(r,a0);
   [p2,dp2] = willoughby2_p_noblend(r,a);
   disp(sprintf('%12.4e %12.4e',(p1 - p0)/(a1(ii) - a0(ii)), dp2(:,ii)));
end
del = 1e-8;
r1 = r*(1 + del); [p1,dp1] = willoughby2_p_noblend(r1,a);
r0 = r*(1 - del); [p0,dp0] = willoughby2_p_noblend(r0,a);
[p2,dp2] = willoughby2_p_noblend(r,a);
disp(sprintf('%12.4e %12.4e',(p1 - p0)/(r1 - r0), dp2(:,9)));

% Check derivatives of full version
a = [30 5e4 20 3e6 22e3 1.5 92000 298]';
r = [ 18e3 ];
for ii = 1 : 8
   del = 1e-06; 
   a1 = a; a1(ii) = a1(ii)*(1 + del);
   [p1,dp1] = willoughby2_p_numerical(r,a1);
   a0 = a; a0(ii) = a0(ii)*(1 - del);
   [p0,dp0] = willoughby2_p_numerical(r,a0);
   [p2,dp2] = willoughby2_p_numerical(r,a);
   disp(sprintf('%12.4e %12.4e',(p1 - p0)/(a1(ii) - a0(ii)), dp2(:,ii)));
end
del = 1e-8;
r1 = r*(1 + del); [p1,dp1] = willoughby2_p_numerical(r1,a);
r0 = r*(1 - del); [p0,dp0] = willoughby2_p_numerical(r0,a);
[p2,dp2] = willoughby2_p_noblend(r,a);
disp(sprintf('%12.4e %12.4e',(p1 - p0)/(r1 - r0), dp2(:,9)));

% Check derivatives of fixblend version
clear
clear global
global w2_fix_rblend
a = [30 5e4 50 1e5 22e3 1.5 95000 298]';
w2_fix_rblend = a(5);
f =  cor(15);
r = [ 27.01e3 ];
for ii = 1 :  8
   del = 1e-06;
   a1 = a; a1(ii) = a1(ii)*(1 + del);
   [p1,dp1] = willoughby2_p_num_fixblend(r,a1,f);
   a0 = a; a0(ii) = a0(ii)*(1 - del);
   [p0,dp0] = willoughby2_p_num_fixblend(r,a0,f);
   [p2,dp2] = willoughby2_p_num_fixblend(r,a,f);
   d1 = (p1 - p0)/(a1(ii) - a0(ii));
   d2 = dp2(:,ii);
   disp(sprintf('%12.4e %12.4e %2d', d1, d2, abs(d1-d2) <= 1e-4*max(abs(d1),abs(d2))));
end
del = 1e-6;
r1 = r*(1 + del); [p1,dp1] = willoughby2_p_num_fixblend(r1,a,f);
r0 = r*(1 - del); [p0,dp0] = willoughby2_p_num_fixblend(r0,a,f);
[p2,dp2] = willoughby2_p_num_fixblend(r,a,f);
d1 = (p1 - p0)/(r1 - r0);
d2 = dp2(:,9);
disp(sprintf('%12.4e %12.4e %2d', d1, d2, abs(d1-d2) <= 1e-5*max(abs(d1),abs(d2))));

% Test mrqmin fitting
clear
clear global
global f0
aa = [30,50e3,20,300e3,22e3,1.5,95000,298]'; na = length(aa);
f0 = cor(15); 
r = 1e3*[5:9 20:1:35  80:4:100]'; nr = length(r);
%r = 1e3*[1 3 20:1:30  80:4:100 200:100:1000]'; nr = length(r);
sig = 100*ones(nr,1); 
rfit = 1e3*[0 : 120]'; drfit = rfit(2) - rfit(1);
ptrue = willoughby2_p_noblend(rfit,aa,f0);
% penv = willoughby2_p_numerical(1e6,aa,f0);
vtrue = willoughby2_v(rfit,aa);
vmtrue = aa(1) + aa(3);

global w2p_rmhat w2p_rmscal w2p_L1hat w2p_L1scal w2p_L2hat w2p_L2scal
w2p_rmhat =  22e3; w2p_rmscal = 1;
w2p_L1hat =  50e3; w2p_L1scal = 1;
w2p_L2hat = 300e3; w2p_L2scal = 1;

nmc = 100;
vmfit = zeros(nmc,1); amc = zeros(nmc,na);
chisq = zeros(nmc,1); chisq1 = chisq;
pomc = zeros(nmc,nr);
for ii = 1 : nmc
   po = willoughby2_p_noblend(r,aa) + sig.*randn(nr,1);
   pomc(ii,:) = po';

   a0 = [40 70e3 20 400e3 30e3 1 95000 298]';
   a0 = aa;
   ia = [1 1 1 1 1 1 1 0]';
   
   % Fudge to keep length scale  and rm under control
   r1 = [ r ; -999.0 ];
   po1 = [ po ; 0 ];
   sig1 = [ sig ; 100 ];
   
   [a,cov,chisq(ii)] = mrqmin(r1, po1, sig1, a0, ia, 'willoughby2_p_noblend', 100, 10);

   amc(ii,:) = a';
   
   pfit = willoughby2_p_noblend(rfit,amc(ii,:)');
   vfit = willoughby2_v(rfit,amc(ii,:)');
   vmfit(ii) = a(1) + a(3);
   
   if nmc == 1
      fig(1); clf;
      subplot(3,1,1); cla;
      plot(r/1e3,pomc(ii,:)/1e2,'bo'); hold on; xlim(0,120); ylim(940,1010);
      plot(rfit/1e3,pfit/1e2,'r');
      plot(rfit/1e3,ptrue/1e2,'g-');
      subplot(3,1,2); cla;
      plot(rfit/1e3,(pfit-ptrue)/1e2,'r'); hold on; xlim(0,120);
      subplot(3,1,3); cla;
      plot(rfit/1e3,vfit,'r'); hold on; xlim(0,120); ylim(0,60);
      plot(rfit/1e3,vtrue,'g-');     
      reltext(0.5,0.8,sprintf('vm true=%.1f fit=%.1f m/s',vmtrue,vmfit(ii)));
   end
end

save test_will2_p

fig(2); clf;
subplot(2,4,1); cla;
plot(vmfit,chisq,'o'); xlabel('vmfit'); vline(vmtrue); ylabel('\chi^2');
subplot(2,4,2); cla;
plot(amc(:,1),chisq,'o'); vline(aa(1)); xlabel('A'); 
subplot(2,4,3); cla;
plot(amc(:,2)/1e3,chisq,'o'); vline(aa(2)/1e3); xlabel('L1'); 
subplot(2,4,4); cla;
plot(amc(:,3),chisq,'o'); vline(aa(3)); xlabel('B'); 
subplot(2,4,5); cla;
plot(amc(:,4)/1e3,chisq,'o'); vline(aa(4)/1e3); xlabel('L2'); ylabel('\chi^2');
subplot(2,4,6); cla;
plot(amc(:,5)/1e3,chisq,'o'); vline(aa(5)/1e3); xlabel('rm');
subplot(2,4,7); cla;
plot(amc(:,6),chisq,'o'); vline(aa(6)); xlabel('n');
subplot(2,4,8); cla;
plot(amc(:,7)/1e2,chisq,'o'); vline(aa(7)/1e2); xlabel('pc');

% Test for significance of fitting second exponential
clear;
aa = [30,50e3,20,300e3,22e3,95000]'; na = length(aa);
f = cor(15); rho = 1.15;
r = 1e3*[1 3 20:1:30  80:4:100 200:100:1000]'; nr = length(r);
%r = 1e3*[5:5:95]'; nr=length(r);
sig = 100*ones(nr,1); 
rfit = 1e3*[0 : 120]'; drfit = rfit(2) - rfit(1);
ptrue = willoughby2_p_numerical(rfit,aa,f);
penv = willoughby2_p_numerical(1e6,aa,f);
vtrue = willoughby2_v(rfit,aa);
vmtrue = aa(1) + aa(3);

po = willoughby2_p_numerical(r,aa);
%a0 = aa .* (1 + 0.05*randn(size(aa))); a0(2) = 70e3;
a0 = [52 70e3 2 400e3 30e3 95000]';
dela = [5 5e3 5 20e3 1e3 1e3]';

% Fudge to keep length scale  and rm under control
if 1
   r1 = [ r ; -999.0 ]; po1 = [ po ; 0 ]; sig1 = [ sig ; 1 ];
else
   r1 = r; po1 = po; sig1 = sig;
end

[a1,cov,chisq1] = mrqmin(r1, po1, sig1, a0, 'willoughby2_p_noblend', 100, 2);
% [a,cov,chisq(ii)] = mrqmin(r1, po1, sig1, a1,  'willoughby2_p_numerical', 100, 2);
[a,chisq,nf] = nlinfit_amoeba(r1, po1, sig1, a1, dela, 'willoughby2_p_numerical', 1e-3, 200);

pfit = willoughby2_p_numerical(rfit,a);
vfit = willoughby2_v(rfit,a);
vmfit = a(1) + a(3);

fig(1); clf;
subplot(3,1,1); cla;
plot(r/1e3,po/1e2,'bo'); hold on; xlim(0,120); ylim(940,1010);
plot(rfit/1e3,pfit/1e2,'r');
plot(rfit/1e3,ptrue/1e2,'g-');
subplot(3,1,2); cla;
plot(rfit/1e3,(pfit-ptrue)/1e2,'r'); hold on; xlim(0,120);
subplot(3,1,3); cla;
plot(rfit/1e3,vfit,'r'); hold on; xlim(0,120); ylim(0,60);
plot(rfit/1e3,vtrue,'g-');     
reltext(0.5,0.8,sprintf('vm true=%.1f fit=%.1f m/s',vmtrue,vmfit));
