a = [30 50e3 20 250e3 30e3 2 95000 298 10e3]';
dr = 2e2;
f = cor(15);
r = [0:dr:100e3]';
[v,dv] = willoughby2_v(r,a);
fig(1); clf; 

subplot(2,3,1); cla; plot(r/1e3,v);
subplot(2,3,2); cla; plot(r/1e3,dv(:,1));
subplot(2,3,3); cla; plot(r/1e3,dv(:,2));
subplot(2,3,4); cla; plot(r/1e3,dv(:,3));
subplot(2,3,5); cla; plot(r/1e3,dv(:,4));
subplot(2,3,6); cla; plot(r/1e3,dv(:,5));

% Check derivatives of full version
a = [30 5e4 20 3e6 22e3 1.5 92000 298 10e3]';
r = [ 18e3 ];
for ii = 1 : 9 
   del = 1e-06; 
   a1 = a; a1(ii) = a1(ii)*(1 + del);
   [v1,dv1] = willoughby2_v(r,a1);
   a0 = a; a0(ii) = a0(ii)*(1 - del);
   [v0,dv0] = willoughby2_v(r,a0);
   [v2,dv2] = willoughby2_v(r,a);
   disp(sprintf('%12.4e %12.4e',(v1 - v0)/(a1(ii) - a0(ii)), dv2(:,ii)));
end
del = 1e-8;
r1 = r*(1 + del); [v1,dv1] = willoughby2_v(r1,a);
r0 = r*(1 - del); [v0,dv0] = willoughby2_v(r0,a);
[v2,dv2] = willoughby2_v(r,a);
disp(sprintf('%12.4e %12.4e',(v1 - v0)/(r1 - r0), dv2(:,10)));

