function [vc,dvc] = vaz(uv, xy, a)
% Used with mrqmin_proj to fit analytical profiles to wind data.
% Returns the azimuthal wind component about the point (0,0) for wind vectors
% uv(ii,:) at points xy(ii,:). This version doesn't allow for perturbing the
% cyclone centre and so a is not used ... thus the derivatives dvc of vc with 
% respect to the components of a are all 0.

r = hypot(xy(:,1), xy(:,2));
xr = xy(:,1)./r; yr = xy(:,2)./r;

vc = -uv(:,1).*yr + uv(:,2).*xr;    % Project into cylindrical coordinates

dvc = zeros( size(uv,1), length(a) );

