function [xc,yc,rms] = wi_ch(xo,yo,diro,wo)
% function [xc,yc,rms] = wi_ch(xo,yo,diro,wo)

if nargin <= 3
   wo = ones(size(xo));
end

no = size(xo,1);
if size(yo) ~= [no 1] | size(diro) ~= [no 1] | size(wo) ~= [no 1]
   disp('wi_ch: argument size mismatch');
   xc = nan; yc = nan;
   return
end

sdir = sin(diro*pi/180);
cdir = cos(diro*pi/180);
term = xo.*sdir + yo.*cdir;

a11 = sum(wo.*sdir.^2);
a12 = sum(wo.*sdir.*cdir);
a22 = sum(wo.*cdir.^2);
b1 = sum(wo.*sdir.*term);
b2 = sum(wo.*cdir.*term);

A = [a11 a12; a12 a22];
b = [b1 ; b2];

xx = A\b;

xc = xx(1); yc = xx(2);

rms = sqrt( sum( wo.*((xo-xc).*sdir + (yo-yc).*cdir).^2 ) / sum(wo) );

